var api = "http://pool-reward-balancer-787805100.ap-south-1.elb.amazonaws.com/api/6.0/O1qwCefFuDRfixCc37BStEvXvbV90sgg/"
var adPopUpApplyCode = true;
function checkConnection(){
    $.ajax({
       type: "GET",
       url: api+'connect',
       success: function(r){
         if(r.type == 'error') {
            navigator.notification.alert(r.message);
            return false;
         }
       },
       error: function(XMLHttpRequest, textStatus, errorThrown) {
           if(XMLHttpRequest.status == 0) {
               alert('Oopps seems like your connection with "Reward Server" is almost dead!')
               navigator.app.exitApp();
               return false;
           }
       }
     });
}

function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

function response(html,container){
    if(container == undefined){
        container = '#ajax-response';
    }
    var c = $(container);
    c.fadeOut('fast',function () {
        c.html(html);
        c.fadeIn();
    });
}

function response_text(text){
    var html="";
    html += "<div class=\"response-text\">";
    html += text;
    html += "<\/div>";
    return html;
}

function setUniqueID(id){
    var old = localStorage.getItem('uniqueId');
    if(old != id){
        localStorage.setItem('uniqueId', id);
    }
}

function callAPI(call,onstart,oncomplete,onError,method,DATA){
    if(DATA == undefined){
        DATA = [];
    }
    if(method == undefined){
        method = "GET";
    }
    $.ajax({
        type       : method,
        url        : api+call,
        data       : DATA,
        crossDomain: true,
        cache: false,
        beforeSend : function() {
            if(onstart != undefined) {
                onstart();
            }
        },
        success    : function(response) {
            if(oncomplete != undefined) {
                oncomplete($.parseJSON(response));
            }
        },
        error      : function(XMLHttpRequest, textStatus, errorThrown) {
            if(onError != undefined){
                onError(XMLHttpRequest);
            }
            if(XMLHttpRequest.status == 0) {
               navigator.notification.alert('Oopps seems like your connection with "Reward Server" is almost dead!');
           }
        }
    });
}

function delay(fnc,time){
    if(time == undefined){
        time = 2000;
    }
    setTimeout(function () {
        fnc();
    },time);
}


function rewardPageReset(){
        var html="";
        html += "                                <h4>you have not claimed any reward code yet? Claim your rewards now !! <\/h4>";
		html += "<div class=\"response-text bg-light-red\">";
        html += "                                ";
        html += "                                <strong>Note:<\/strong>if you repeat this process some codes will not work for you, Please wait until we add";
        html += "                                new code and notify you.";
        html += "                            <\/div>";
        response(html);
        $("#reward-btn-spinner").addClass('hidden');
        $(".bar-loader").fadeOut();
        $("#claim-rewards").removeAttr('disabled');
}

function connect(onComplete){
    callAPI('connect',function(){
        response(response_text('please wait connecting to rewards server'));
    },function (r) {
        if(r.type == 'success') {
            delay(function () {
                response('<p class="text-success pad-10">Connected :)</p>');
                delay(function () {
                    if(onComplete != undefined){
                        onComplete();
                    }
                },1000);
            });
        }else{
            response(response_text(r.message));
            navigator.notification.alert(r.message);
        }
    },function(httpRequest){
        if(httpRequest.status != 0){
            navigator.notification.alert('Server is too busy to respond try again!');
        }
        rewardPageReset();
    });
}

function getRewards(onComplete,beforeSend,onError){
    if(beforeSend != undefined){
        beforeSend();
    }
    callAPI('get-rewards',function () {
        response(response_text('Downloading rewards from server . . .'));
    },function (r) {
        if(r.type == 'error') {
            response_text(r.message);
            navigator.notification.alert(r.message);
        }else{
            delay(function () {
                response('<p class="text-success pad-10">Downloaded :)</p>');
                delay(function () {
                    response(response_text('Total rewards found: '+r.length));
                    delay(function () {
                        response(response_text('Starting to apply rewards on user "'+$("#miniclip-uniqueID").val()+'"'));
                        if(onComplete != undefined){
                            onComplete(r);
                        }
                    });
                },1000);
            },1000);
        }
    },function(httpRequest){
        if(httpRequest.status != 0){
            navigator.notification.alert('Server is too busy to respond try again!');
        }
        rewardPageReset();
        if(onError != undefined){
            onError(httpRequest);
        }
    });
}

function applyCode($this,code){
    
    var uniqueID = $("#miniclip-uniqueID-list").val();
    
    if(uniqueID.length <= 0){
       navigator.notification.alert('Please enter your Unique ID!');
       return false;
    }
    if($.isNumeric(uniqueID) === false){
       navigator.notification.alert('Please enter only numbers');
       return false;
    }
    if(code.length <= 0){
       navigator.notification.alert('Please enter reward code!');
       return false;
    }
    setUniqueID(uniqueID);
    $($this).addClass('disabled');
    $($this).attr('disabled','disabled');
    callAPI('apply-reward',function () {
        $($this).html('<i class="fa fa-spinner" aria-hidden="true"></i> applying..');
    },function (r) {
        if(r.type == 'success'){
            $($this).html('Success <i class="fa fa-hand-peace-o" aria-hidden="true"></i>');
        }else{
            $($this).html('Error <i class="fa fa-times" aria-hidden="true"></i>');
            navigator.notification.alert(r.message);
        }
    },function(httpRequest){
        if(httpRequest.status != 0){
            navigator.notification.alert('Server is too busy to respond try again!');
        }
        $($this).removeClass('disabled');
        $($this).removeAttr('disabled');
        $($this).html('Apply');
    },'POST',{uniqueid: uniqueID,code: code});
    
    if(adPopUpApplyCode){
        delay(function(){
            var admobid2 = {
              interstitial: 'ca-app-pub-6746517942956278/9443924549'
           };
           if(AdMob) AdMob.prepareInterstitial( {adId:admobid2.interstitial, autoShow:true} );
        },10000);
        adPopUpApplyCode = false;
    }
    
}

var current = 0;
var amount = 0;
var items = 0;
var retry = 0;
function applyCodes(id,rewards){
    if(current == rewards.length){
        var html="";
        html += "";
        html += "                            <button class=\"mdl-button mdl-js-button mdl-button--fab button-success\">";
        html += "                            <i class=\"fa fa-hand-peace-o\" aria-hidden=\"true\"></i>";
        html += "                            <\/button>";
        html += "                            <div class=\"success\">";
        html += "                            <h1>Congrats<\/h1>";
        html += "                            <p>Total <span class=\"amount\">"+amount+"<\/span> coins";
        if(items > 0) {
            html += "                               & " + items + " items";
        }
        html += "                               are transfered on your account :) have fun!<\/p>"
        html += "                            <p class=\"color-red bg-light-white\">We will notify you when there is more new rewards<\/p>";
        html += "                            <\/div>";
        response(html);
        $("#reward-btn-spinner").addClass('hidden');
        $(".bar-loader").fadeOut();
        $("#claim-rewards").removeAttr('disabled');
        current = 0;
        amount = 0;
        items = 0;
        retry = 0;
        
        var admobid3 = {
          interstitial: 'ca-app-pub-6746517942956278/9443924549'
        };
        if(AdMob) AdMob.prepareInterstitial( {adId:admobid3.interstitial, autoShow:true} );
        
        return false;
    }
    var code = rewards[current].code;
    callAPI('apply-reward',function () {
        response(response_text('Applying reward '+(current + 1)+'/'+rewards.length));
    },function (r) {
        if(r.type == 'success'){
                if(rewards[current].ctype == '1') {
                    amount += parseInt(r.message);
                }
                if(rewards[current].ctype == '2'){
                    items++;
                }
                response('<p class="text-success">'+response_text(r.message)+'</p>');
        }else{
            response('<div class="bg-light-red pad-5">'+response_text(r.message)+'</div>');
        }
        retry = 0;
        current++;
        delay(function () {
            applyCodes(id,rewards);
        },1000);
    },function(httpRequest){
        response(response_text('Oops we failed to apply your reward!'));
        if(retry > 2){
            navigator.notification.alert('Server is too busy to respond try later!');
            current = 0;
            amount = 0;
            items = 0;
            retry = 0;
            rewardPageReset();
        }else{
            delay(function(){
                if(retry == 0){
                    response(response_text('retrying. . .'));
                }else{
                    response(response_text('('+(retry + 1)+') retrying. . .'));
                }
                delay(function(){
                    applyCodes(id,rewards);
                    retry++;
                },2000);
            },1000);
        }
    },'POST',{uniqueid: id,code: code});
}

function updateClickArea(nativeId,refId){
	if (nativeId != null) {
		// change the click area
		var offset = $("#"+refId).offset();
		var y = offset.top - $(window).scrollTop();
		var x = offset.left - $(window).scrollLeft();
		var w = $("#"+refId).width();
		var h = $("#"+refId).height();
		if(FacebookAds) FacebookAds.setNativeAdClickArea(nativeId, x, y, w, h);
	}
}

function nativeAdHtml(adRes){
    var html="";
    html += "  <div class=\"ad-native\">";
    html += "    <div class=\"title\">"+adRes.title+"<\/div>";
    html += "    <p class=\"body\">";
                    html += adRes.body;
    html += "    <\/p>";
    html += "    <span class=\"btn\">"+adRes.buttonText+"<\/span><br /><br />";
    html += "    <p class=\"sbody\">"+adRes.socialContext+"<\/p>";
    html += "    <div class=\"img\">";
    html += "      <img src=\"" + adRes.icon.url + "\" width=\"" + adRes.icon.width + "\" height=\"" + adRes.icon.height + "\" \/>";
    html += "    <\/div>";
    html += "  <\/div>";
    return html;
}

function nativeAdHtmlList(adRes){
    var html="";
    html += "<div class=\"ad-native-list\">";
        html += "    <div class=\"img\">";
            html += "    <div>";
                html += "      <img src=\"" + adRes.icon.url + "\" \/>";
            html += "    </div>";
            html += "    <div class='btn-div'>";
                html += "    <span class=\"btn\">"+adRes.buttonText+"<\/span>";
            html += "    </div>";
        html += "    <\/div>";
        html += "    <div class=\"container\">";
            html += "    <div class=\"title\">"+adRes.title+"<\/div>";
            html += "    <p class=\"body\">";
                            html += adRes.body;
            html += "    <\/p>";
            html += "    <p class=\"sbody\">"+adRes.socialContext+"<\/p>";
        html += "    <\/div>";
    html += "  <\/div>";
    return html;
}